/* Copyright 2023 Kevin Ryde

   This file is part of pari-primecount.

   pari-primecount is free software; you can redistribute it and/or modify it
   under the terms of the GNU General Public License as published by the Free
   Software Foundation; either version 3, or (at your option) any later
   version.

   pari-primecount is distributed in the hope that it will be useful, but
   WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
   or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
   for more details.

   You should have received a copy of the GNU General Public License along
   with pari-primecount.  If not, see <http://www.gnu.org/licenses/>.
*/

#include <limits.h>
#include <stdio.h>
#include <stdlib.h>
#include <inttypes.h>
#include <primecount.h>

#define LONG_BIT   (CHAR_BIT * sizeof(long))


int
main(void)
{
  setbuf(stdout,NULL);
  if (1) {
    unsigned x = (UINT_MAX >> 31) >> 1;
    printf("shift 32 = %x\n", x);
    exit(0);
  }
  if (1) {
    printf("primecount_phi()\n");
    int64_t x = INT64_MAX;
    int64_t a = 1000;
    printf("  x = %"PRId64"  a = %"PRId64"\n", x, a);
    int64_t phi = primecount_phi(x,a);
    printf("  phi = %"PRId64"\n", phi);
    exit(0);
  }
  if (1) {
    printf("primecount_pi_str()\n");
    char str[] = "8888888888888888888888888888888888888888888888888888888888888888888888888888888888888";
    printf("  str = %s\n", str);
    char out[32];
    int ret = primecount_pi_str(str, out, sizeof(out));
    printf("  ret = %d\n", ret);
    printf("  ret = %d  out = \"%s\"\n", ret, out);
  }
  if (1) {
    printf("primecount_pi()\n");
    int64_t x = -1;
    printf("  x = %"PRId64"\n", x);
    int64_t pi = primecount_pi(x);
    printf("  pi = %"PRId64"\n", pi);
  }
  return (0);
}
