\\ Copyright 2022 Kevin Ryde

\\ This file is free software; you can redistribute it and/or modify it
\\ under the terms of the GNU General Public License as published by the Free
\\ Software Foundation; either version 3, or (at your option) any later
\\ version.
\\
\\ This file is distributed in the hope that it will be useful, but
\\ WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
\\ or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
\\ for more details.
\\
\\ You should have received a copy of the GNU General Public License along
\\ with this file.  If not, see <http://www.gnu.org/licenses/>.


default(recover,0);
default(strictargs,1);
read("../nthprimeweb.gp");

check_count = 0;
check_equal(got,want,name="") =
{
  check_count++;
  if(got != want,
     print("wrong "name);
     print("got  "got);
     print("want "want);
     quit(1),
     print("ok "check_count" "name));
}

my_prime(n) =
{
  if(n < 10^8,
     prime(n), 
     print("nthprimeweb_prime() len=",#digits(n),"  ",n);
     nthprimeweb_prime(n));
}


\\-----------------------------------------------------------------------------
\\ A356082 complete binary

{
  my(want=OEIS_data("A356082"),
     n=1,
     p=1);
  while(1,
        check_equal(p, want[n],
                    Str("A356082 complete binary n="n));
        if(p > 10^12, break);
        p = my_prime(p)^2;
        n++);
  print("A356082 check stop at n="n" p="p" len=",#digits(p));
}


\\-----------------------------------------------------------------------------
\\ A352289 caterpillar down

\\ OEIS_data("A352289")
\\ apply(t->#digits(t), OEIS_data("A352289"))
{
  my(want=OEIS_data("A352289"),
     n=1,
     p=1);
  while(1,
        check_equal(p, want[n],
                    Str("A352289 caterpillar n="n));
        if(p > 10^12, break);
        p = 2*my_prime(p);
        n++);
  print("A352289 check stop at n="n" p="p" len=",#digits(p));
}

\\-----------------------------------------------------------------------------
\\ A007097 prime'th recurrence

\\ apply(t->#digits(t), OEIS_data("A007097"))
{
  my(a=OEIS_data_func("A007097"),
     n=0,
     p=1);
  while(1,
        check_equal(p, a(n),
                    Str("A007097 primeth n="n));
        if(p > 10^12, break);
        p = my_prime(p);
        n++);
  print("A007097 check stop at n="n" p="p" len=",#digits(p));
}

\\-----------------------------------------------------------------------------
